Unit
  Error32;

{$MODE OBJFPC}
{$H+}

Interface

Function ErrToStr(Const ErrNo: DWORD): String;

Implementation

Uses
  Windows;

Function DWToStr(Const D: DWORD): String;
  Var
    S: String;
  Begin
  Str(D, S);
  DWToStr := S;
  End;

Function ErrToStr(Const ErrNo: DWORD): String;
  Var
    pBuffer: PChar;
  Begin
  If FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER Or FORMAT_MESSAGE_FROM_SYSTEM,
                 Nil,
                 ErrNo,
                 MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                 @pBuffer,
                 0,
                 Nil) > 0 Then
    Begin
    Result := 'Error ' + DWToStr(ErrNo) + ': ' + pBuffer;
    LocalFree(HLOCAL(pBuffer));
    End
  Else
    Result := 'Error ' + DWToStr(ErrNo) + #13#10;
  End;

Begin
End.
